<?php
namespace App\Http\Controllers\Admin;
use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\ProductType;

class ProductTypeController extends Controller
{
    public function index(){
        $products = ProductType::all();
        return view('Admin.ProductType.index', compact('products'));
    }
    public function store(Request $request)
    {
        $request->validate([
            'title' => 'required',
            'sku' => 'required',
        ]);

        // Save the data to the database
        $producttype = new ProductType();
        $producttype->title = $request->title;
        $producttype->sku = $request->sku;
        $producttype->save();
        $URL = route('product-type.destroy', $producttype->id);
        $csrf = csrf_token();
        $new_product = <<<EOF
            <tr class="product-row">
                <td>$producttype->title</td>
                <td>$producttype->sku</td>
                <td>
                    <form action="$URL" method="POST">
                        <input type="hidden" name="_token" value="$csrf">
                        <input type="hidden" name="_method" value="DELETE">
                        <div class="btn-group btn-group-sm" role="group" aria-label="...">
                            <button type="button" class="btn btn-warning" product-id="$producttype->id" onclick="edit_product_model(this)" data-toggle="modal" data-target="#ProductModalCenter">Edit</button>
                            <button class="btn btn-danger" type="submit" onclick="return confirm('Are you sure?')">Delete</button>
                        </div>
                    </form>
                </td>
            </tr>
EOF;

        return response()->json([
            'status' => 'success',
            'message' => 'Product Type saved successfully.',
            'new_category' => $new_product,
        ]);
    }
    public function destroy(Request $request, ProductType $product_type)
    {

        $product_type->delete();

        return redirect()->route('product-type.index');
    }

    public function show(ProductType $product_type)
    {
        return response()->json([
            'status' => true,
            'product_details' => $product_type,
        ]);
    }
    public function update(Request $request, $id)
    {
        $product = ProductType::findOrFail($id);

        $request->validate([
            'title' => 'required',
            'sku' => 'required',
        ]);

        $product->title = $request->title;
        $product->sku = $request->sku;
        $product->save();
        $URL = route('product-type.destroy', $product->id);
        $csrf = csrf_token();
        $updated_product = <<<EOF
                <td>$product->title</td>
                <td>$product->sku</td>
                <td>
                    <form action="$URL" method="POST">
                        <input type="hidden" name="_token" value="$csrf">
                        <input type="hidden" name="_method" value="DELETE">
                        <div class="btn-group btn-group-sm" role="group" aria-label="...">
                            <button type="button" class="btn btn-warning" product-id="$product->id" onclick="edit_product_model(this)" data-toggle="modal" data-target="#ProductModalCenter">Edit</button>
                            <button class="btn btn-danger" type="submit" onclick="return confirm('Are you sure?')">Delete</button>
                        </div>
                    </form>
                </td>
EOF;
        return response()->json([
            'status' => 'success',
            'message' => 'Product updated successfully.',
            'updated_row' => $updated_product,
        ]);
    }

}
