<?php

namespace App\Http\Controllers\Admin\Traits;

use Illuminate\Http\Request;
use App\Models\Invoices;
use DB;
use App\Models\UserMeta;
use App\Models\GeneralSettings;
use App\General\UserClass;
use App\General\GeneralSettingsClass;

trait InvoiceTrait
{
    public function ReviewInvoice($id)
    {
        $settings = GeneralSettings::get();
        # Company Details
        $company_logo = url('/') . "/" . GeneralSettingsClass::getOptionValue('_header_logo', $settings);
        $company = GeneralSettingsClass::getOptionValue('_b_name', $settings);
        $company_address = GeneralSettingsClass::getOptionValue('_b_street_address', $settings);
        $company_state_country = GeneralSettingsClass::getOptionValue('_b_area_address', $settings);
        $company_email = GeneralSettingsClass::getOptionValue('_b_email', $settings);
        $company_phone = GeneralSettingsClass::getOptionValue('_b_number', $settings);
        $company_fax = "(123) 456-0987";

        $GST = config('app.PERCENTAGE') ?? 0;
        $pos_invoice_note = GeneralSettingsClass::getOptionValue('_pos_invoice_note', $settings);

        $invoice = Invoices::find($id);
        if ($invoice) {
            $customer_details = "";
            if ($invoice->customer_type == "existing") {
                $UserMeta = UserMeta::where('user_id', $invoice->customer)->get();
                $customer_details = '<strong>' . UserClass::getOptionValue('_b_name', $UserMeta) . '</strong><br>
                                    ' . UserClass::getOptionValue('_b_street_address', $UserMeta) . '<br>
                                    ' . UserClass::getOptionValue('_b_area_address', $UserMeta) . '<br>
                                    <abbr title="Email">E:</abbr> ' . UserClass::getOptionValue('_b_email', $UserMeta) . '
                                    <br>
                                    <abbr title="Phone">P:</abbr> ' . UserClass::getOptionValue('_b_number', $UserMeta) . '';
            } else if ($invoice->customer_type == "random") {
                $customer_details = "<strong>" . $invoice->customer . "</strong>";
            }

            $invoice_items = "";
            $i = 1;
            foreach ($invoice->invoiceMeta as $invoice_item) {
                $invoice_items = $invoice_items . '<tr>
                                    <td>' . $i . '</td>
                                    <td>' . $invoice_item->product_name . '</td>
                                    <td>' . $invoice_item->units . '</td>
                                    <td>$' . $invoice_item->unit_price . '</td>
                                    <td class="text-right">$' . $invoice_item->unit_total_price . '</td>
                                </tr>';
                $i++;
            }

            $invoice_template = <<<INVOICE
                <h5 class="card-title bd-b pd-y-20">Invoice <a href="" class="tx-dark">#$invoice->invoice_number</a></h5>
                <div class="card-body pd-0 printing-area">
                    <img src="$company_logo" style="filter: invert(1); !important;width:200px" class="img-fluid" alt="logo"><br><br>
                    <div class="row">
                        <div class="col-md-4">
                            <h4 class="text-dark">From:</h4>
                            <address>
                                <strong>$company</strong><br>
                                $company_address<br>
                                $company_state_country<br>
                                <abbr title="Email">E:</abbr> $company_email
                                <br>
                                <abbr title="Phone">P:</abbr> $company_phone
                                <br>
                                <abbr title="Fax">F:</abbr> $company_fax
                            </address>
                        </div>
                        <div class="col-md-4 ml-md-auto text-md-right">
                            <h4 class="text-dark">To:</h4>
                            <address>
                                $customer_details
                            </address>
                        </div>
                    </div>
                    <div class="row mb-5">
                        <div class="col-md-4">
                            <span><strong>Payment Method:</strong> $invoice->payment_method</span>
                            <br>
                            <span><strong>Payment Status:</strong> $invoice->payment_status</span>
                        </div>
                        <div class="col-md-4 ml-md-auto text-md-right">
                            <span><strong>Invoice Date:</strong> $invoice->invoice_date</span>
                            <br>
                            <span><strong>Due Date:</strong> $invoice->due_date</span>
                        </div>
                    </div>
                    <div class="table-responsive">
                        <table class="table table-hover">
                            <thead>
                                <tr>
                                <th>#</th>
                                <th>Description</th>
                                <th>Quantity</th>
                                <th>Unit Cost</th>
                                <th class="text-right">Total</th>
                                </tr>
                            </thead>
                            <tbody>
                                $invoice_items
                            </tbody>
                        </table>
                    </div>
                    <hr>
                    <div class="row orderDetailsClass">
                        <div class="col-md-6">
                            <h5>Notes</h5>
                            <p>$invoice->payment_id</p>
                            <p>$pos_invoice_note</p>
                        </div>
                        <div class="col-md-4 ml-md-auto invoiceDetailInner">
                            <span class="d-inline-block">
                            Sub - Total amount: &nbsp;&nbsp;&nbsp;<b>$$invoice->sub_total</b><br><hr>
                            General Discount: &nbsp;&nbsp;&nbsp;-$invoice->discount%<br>
                            Discounted Total: &nbsp;&nbsp;&nbsp;<b>$$invoice->discounted_amount</b><br><hr>
                            Membership Discount ($invoice->membership_discount_percentage%): &nbsp;&nbsp;&nbsp;-$$invoice->membership_dicount<br>
                            Membership Discounted Total: &nbsp;&nbsp;&nbsp;<b>$$invoice->membership_dicounted_total</b><br><hr>
                            <p class="tx-gray-500 tx-12">GST ($GST%): &nbsp;&nbsp;&nbsp;+$$invoice->gst</p>
                            </span>
                            <br><br>
                            <p class="tx-bold">Grand Total: <span class="tx-20 tx-gray-900">&nbsp;&nbsp;&nbsp;<b>$$invoice->grand_total</b></span></p>
                            <br>
                        </div>
                    </div>
                </div>
INVOICE;
            return $invoice_template;
        }
    }
}
